#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/stat.h>
#include <errno.h>
#include <unistd.h>
#include <locale.h>
#include <libintl.h>
#include <signal.h>
#include <string.h>
#include "vnctermserv.h"

int CreateListen(int Port)
{
int sock;struct sockaddr_in s;
if((sock=socket(AF_INET,SOCK_STREAM,0))==-1)return -1;
memset(&s,0,sizeof(s));
s.sin_family=AF_INET;s.sin_port=htons(Port);
s.sin_addr.s_addr=INADDR_ANY;
if(bind(sock,(struct sockaddr*)&s,sizeof(s))==-1){close(sock);return -1;}
if(listen(sock,5)==-1){close(sock);return -1;}
return sock;}

int GetHostIP(struct sockaddr_in* sock,char* Name)
{struct hostent* h;
if(!Name)return 0;
memset(sock,0,sizeof(*sock));
sock->sin_family=AF_INET;
h=gethostbyname(Name);
if(!h) return 0;
sock->sin_family=h->h_addrtype;
sock->sin_addr.s_addr=(*((unsigned long*)h->h_addr_list[0]));
return 1;
}

int socketconnect(char*Name,int port)
{struct sockaddr_in ca; 
int sock=socket(AF_INET,SOCK_STREAM,0);
 if(sock==-1)return sock;
 if(!GetHostIP(&ca,Name))return -1;
 ca.sin_port=htons(port);
 if(connect(sock,&ca,sizeof(ca))==-1)return -1;
 return sock;
}

int freeDisplay(int i)
{int sock;char buf[MAXFILE];
struct sockaddr_in Addr;struct stat s;
if(!GetHostIP(&Addr,"127.0.0.1"))return 0;
Addr.sin_port=htons(6000+i);
if((sock=socket(AF_INET,SOCK_STREAM,0))==-1)return 0;
if(connect(sock,(struct sockaddr*)&Addr,sizeof(Addr))!=-1){close(sock);return 0;}
if(errno!=ECONNREFUSED)return 0;
close(sock);
Addr.sin_port=htons(5900+i);
if((sock=socket(AF_INET,SOCK_STREAM,0))==-1)return 0;
if(connect(sock,(struct sockaddr*)&Addr,sizeof(Addr))!=-1){close(sock);return 0;}
if(errno!=ECONNREFUSED)return 0;
close(sock);
sprintf(buf,"/tmp/.X11-unix/X%d",i);
if(stat(buf,&s)!=-1) return 0;
if(errno!=ENOTDIR&&errno!=ENOENT)return 0;
sprintf(buf,"/tmp/.X%d-lock",i);
if(stat(buf,&s)!=-1) return 0;
if(errno!=ENOTDIR&&errno!=ENOENT)return 0;
return 1;
}

void showmessage(const char*msg,int code)
{if(isremote)
printf("ERROR(%d):%s\n",code,msg);
 else gtkmsg(msg,code);
}

int findDisplay()
{
int i;
for(i=0;i<=99;i++)
if(freeDisplay(i)) return i;
showmessage(gettext("No free display"),2);
exit(1);
}

void genxauth(char* aufile,char*hn,int dnr)
{char hn1[MAXCMDLINE],cookie[50];
int i;
cookie[0]=0;
for(i=0;i<16;i++)sprintf(cookie+strlen(cookie),"%02X",(unsigned char)genrand());
sprintf(hn1,"%s -f '%s' add %s:%d . %s",XAUTH,aufile,hn,dnr,cookie);
system(hn1);
sprintf(hn1,"%s -f '%s' add %s/unix:%d . %s",XAUTH,aufile,hn,dnr,cookie);
system(hn1);
}


void Kill(VNCServ*v,int ID)
{
if(ID==0) return;
ID--;
while(ID>0){v=v->Next;ID--;}
 if(ID==0)
kill(v->PID,SIGTERM);
}

void FreeUsedVnc(VNCServ**v)
{VNCServ**v1,*v2;
v1=v;v2=*v;
while(v2){
if(v2->ConnCount>0)
{*v1=v2->Next;free(v2);v2=*v1;}else
{v1=&v2->Next;v2=v2->Next;}
}
}
int CountVnc(VNCServ*v)
{int i=0;
 while(v){v=v->Next;i++;}
 return i;
}


void updatepwfile(char* homedir)
{char pwdir[MAXFILE];
char data[8];int i;
FILE*of;
sprintf(pwdir,"%s/.vnctermserv",homedir);
mkdir(pwdir,S_IRUSR |S_IWUSR |S_IXUSR);
chmod(pwdir, S_IRUSR |S_IWUSR |S_IXUSR);
sprintf(pwdir,"%s/.vnctermserv/passwd",homedir);
of=fopen(pwdir,"wb");
if(of){
for(i=0;i<8;i++)
data[i]=genrand();
fwrite(&data,8,1,of);
fclose(of);}
chmod(pwdir, S_IRUSR |S_IWUSR);
}

int StartServer(char* homedir,char*pwfile,char* Server,char* Session,char* sessionname,int Depth,int X,int Y)
{char hn[MAXFILE],aufile[MAXFILE];int dnr;char constr[MAXCMDLINE];int pid;
 VNCServ*v1;
hn[0]=0;
gethostname(hn,sizeof(hn)-1);
dnr=findDisplay();
if(getenv("XAUTHORITY")&&strlen(getenv("XAUTHORITY"))<MAXFILE-10)strcpy(aufile,getenv("XAUTHORITY"));
else
sprintf(aufile,"%s/.Xauthority",homedir);
genxauth(aufile,hn,dnr);
strcpy(constr, Server);
if(fork()==0){
setpgrp();
sprintf(constr+strlen(constr)," -auth %s -rfbauth %s -depth %d -geometry %dx%d -rfbport %d :%d >> %s/.vnctermserv/%d.log 2>&1 &",aufile,pwfile,Depth,X,Y,dnr+5900,dnr,homedir,dnr);
system(constr);
sleep(3);
pid=0;
v1=findvnc(getuid());
while(v1){if(dnr==v1->RFBPort)pid=v1->PID;v1=v1->Next;}
sprintf(constr,"%s:%d",hn,dnr);
setenv("DISPLAY",constr,1);
setenv("XAUTHORITY",aufile,1);
sprintf(constr,"sh -c \" (%s %s; kill %d) >> %s/.vnctermserv/%d.log 2>&1 \"&",Session,sessionname,pid,homedir,dnr);
system(constr);
 exit(0);
}
sleep(5);
return dnr;}

int blockwrite(int fd,char*data,int cnt1)
{int i,cnt=cnt1,written=0;
 fd_set w;
 while(cnt>0){
 i=write(fd,data,cnt);
 if(i==-1&&errno==EAGAIN){
 FD_ZERO(&w);
 FD_SET(fd,&w);
 select(fd+1,0,&w,0,0);i=0;
 }else if(i==-1)return i;
 cnt-=i;data+=i;written+=i;
 }
return written;
 }

int copystream(int sock1a,int sock1b,int sock2)
{int max;fd_set r,e;char constr[2000];int i;

 max=sock1a;
 if(sock1b>max)max=sock1b;
 if(sock2>max)max=sock2;
SockNonBlock(sock1a);
SockNonBlock(sock1b);
SockNonBlock(sock2);
FD_ZERO(&r);
FD_ZERO(&e);
lp:
FD_SET(sock1a,&r);
FD_SET(sock1a,&e);
FD_SET(sock2,&r);
FD_SET(sock2,&e);
select(max+1,&r,0,&e,0);
if(FD_ISSET(sock1a,&r)||FD_ISSET(sock1a,&e)){i=read(sock1a,&constr,sizeof(constr));
if(i==-1||i==0) return 0;if(blockwrite(sock2,constr,i)!=i)return 1;
}
if(FD_ISSET(sock2,&r)||FD_ISSET(sock2,&e)){i=read(sock2,&constr,sizeof(constr));
if(i==-1||i==0) return 0;if(blockwrite(sock1b,constr,i)!=i)return 1;
}

goto lp;
}
